<a id="types-aiobotocore-transfer"></a>

# types-aiobotocore-transfer

[![PyPI - types-aiobotocore-transfer](https://img.shields.io/pypi/v/types-aiobotocore-transfer.svg?color=blue)](https://pypi.org/project/types-aiobotocore-transfer)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-transfer.svg?color=blue)](https://pypi.org/project/types-aiobotocore-transfer)
[![Docs](https://img.shields.io/readthedocs/types-aiobotocore.svg?color=blue)](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_transfer/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-transfer?color=blue)](https://pypistats.org/packages/types-aiobotocore-transfer)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.Transfer 2.5.2](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/transfer.html#Transfer)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.14.5](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-transfer docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_transfer/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-transfer](#types-aiobotocore-transfer)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `Transfer` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[transfer]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[transfer]'


# standalone installation
python -m pip install types-aiobotocore-transfer
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-transfer
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[transfer]` in your environment:

```bash
python -m pip install 'types-aiobotocore[transfer]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[transfer]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[transfer]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[transfer]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[transfer]` with services you use in your
  environment:

```bash
python -m pip install 'types-aiobotocore[transfer]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[transfer]` in your environment:

```bash
python -m pip install 'types-aiobotocore[transfer]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[transfer]` in your environment:

```bash
python -m pip install 'types-aiobotocore[transfer]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`TransferClient` provides annotations for `session.create_client("transfer")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_transfer import TransferClient

session = get_session()
async with session.create_client("transfer") as client:
    client: TransferClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_transfer.paginator` module contains type annotations for all
paginators.

```python
from aiobotocore.session import get_session

from types_aiobotocore_transfer import TransferClient
from types_aiobotocore_transfer.paginator import (
    ListAccessesPaginator,
    ListAgreementsPaginator,
    ListCertificatesPaginator,
    ListConnectorsPaginator,
    ListExecutionsPaginator,
    ListProfilesPaginator,
    ListSecurityPoliciesPaginator,
    ListServersPaginator,
    ListTagsForResourcePaginator,
    ListUsersPaginator,
    ListWorkflowsPaginator,
)

session = get_session()
async with session.create_client("transfer") as client:
    client: TransferClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    list_accesses_paginator: ListAccessesPaginator = client.get_paginator("list_accesses")
    list_agreements_paginator: ListAgreementsPaginator = client.get_paginator("list_agreements")
    list_certificates_paginator: ListCertificatesPaginator = client.get_paginator(
        "list_certificates"
    )
    list_connectors_paginator: ListConnectorsPaginator = client.get_paginator("list_connectors")
    list_executions_paginator: ListExecutionsPaginator = client.get_paginator("list_executions")
    list_profiles_paginator: ListProfilesPaginator = client.get_paginator("list_profiles")
    list_security_policies_paginator: ListSecurityPoliciesPaginator = client.get_paginator(
        "list_security_policies"
    )
    list_servers_paginator: ListServersPaginator = client.get_paginator("list_servers")
    list_tags_for_resource_paginator: ListTagsForResourcePaginator = client.get_paginator(
        "list_tags_for_resource"
    )
    list_users_paginator: ListUsersPaginator = client.get_paginator("list_users")
    list_workflows_paginator: ListWorkflowsPaginator = client.get_paginator("list_workflows")
```

<a id="waiters-annotations"></a>

### Waiters annotations

`types_aiobotocore_transfer.waiter` module contains type annotations for all
waiters.

```python
from aiobotocore.session import get_session

from types_aiobotocore_transfer.client import TransferClient
from types_aiobotocore_transfer.waiter import ServerOfflineWaiter, ServerOnlineWaiter

session = get_session()
async with session.create_client("transfer") as client:
    client: TransferClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    server_offline_waiter: ServerOfflineWaiter = client.get_waiter("server_offline")
    server_online_waiter: ServerOnlineWaiter = client.get_waiter("server_online")
```

<a id="literals"></a>

### Literals

`types_aiobotocore_transfer.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from types_aiobotocore_transfer.literals import (
    AgreementStatusTypeType,
    As2TransportType,
    CertificateStatusTypeType,
    CertificateTypeType,
    CertificateUsageTypeType,
    CompressionEnumType,
    CustomStepStatusType,
    DomainType,
    EncryptionAlgType,
    EncryptionTypeType,
    EndpointTypeType,
    ExecutionErrorTypeType,
    ExecutionStatusType,
    HomeDirectoryTypeType,
    IdentityProviderTypeType,
    ListAccessesPaginatorName,
    ListAgreementsPaginatorName,
    ListCertificatesPaginatorName,
    ListConnectorsPaginatorName,
    ListExecutionsPaginatorName,
    ListProfilesPaginatorName,
    ListSecurityPoliciesPaginatorName,
    ListServersPaginatorName,
    ListTagsForResourcePaginatorName,
    ListUsersPaginatorName,
    ListWorkflowsPaginatorName,
    MdnResponseType,
    MdnSigningAlgType,
    OverwriteExistingType,
    ProfileTypeType,
    ProtocolType,
    ServerOfflineWaiterName,
    ServerOnlineWaiterName,
    SetStatOptionType,
    SftpAuthenticationMethodsType,
    SigningAlgType,
    StateType,
    TlsSessionResumptionModeType,
    WorkflowStepTypeType,
    TransferServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    WaiterName,
    RegionName,
)


def check_value(value: AgreementStatusTypeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_transfer.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_transfer.type_defs import (
    As2ConnectorConfigTypeDef,
    HomeDirectoryMapEntryTypeDef,
    PosixProfileTypeDef,
    CreateAccessResponseTypeDef,
    TagTypeDef,
    CreateAgreementResponseTypeDef,
    CreateConnectorResponseTypeDef,
    CreateProfileResponseTypeDef,
    EndpointDetailsTypeDef,
    IdentityProviderDetailsTypeDef,
    ProtocolDetailsTypeDef,
    CreateServerResponseTypeDef,
    CreateUserResponseTypeDef,
    CreateWorkflowResponseTypeDef,
    CustomStepDetailsTypeDef,
    DeleteAccessRequestRequestTypeDef,
    DeleteAgreementRequestRequestTypeDef,
    DeleteCertificateRequestRequestTypeDef,
    DeleteConnectorRequestRequestTypeDef,
    DeleteHostKeyRequestRequestTypeDef,
    DeleteProfileRequestRequestTypeDef,
    DeleteServerRequestRequestTypeDef,
    DeleteSshPublicKeyRequestRequestTypeDef,
    DeleteStepDetailsTypeDef,
    DeleteUserRequestRequestTypeDef,
    DeleteWorkflowRequestRequestTypeDef,
    DescribeAccessRequestRequestTypeDef,
    DescribeAgreementRequestRequestTypeDef,
    DescribeCertificateRequestRequestTypeDef,
    DescribeConnectorRequestRequestTypeDef,
    DescribeExecutionRequestRequestTypeDef,
    DescribeHostKeyRequestRequestTypeDef,
    DescribeProfileRequestRequestTypeDef,
    DescribeSecurityPolicyRequestRequestTypeDef,
    DescribedSecurityPolicyTypeDef,
    DescribeServerRequestRequestTypeDef,
    WaiterConfigTypeDef,
    DescribeUserRequestRequestTypeDef,
    DescribeWorkflowRequestRequestTypeDef,
    LoggingConfigurationTypeDef,
    SshPublicKeyTypeDef,
    EfsFileLocationTypeDef,
    EmptyResponseMetadataTypeDef,
    ExecutionErrorTypeDef,
    S3FileLocationTypeDef,
    ImportCertificateResponseTypeDef,
    ImportHostKeyResponseTypeDef,
    ImportSshPublicKeyRequestRequestTypeDef,
    ImportSshPublicKeyResponseTypeDef,
    S3InputFileLocationTypeDef,
    ListAccessesRequestListAccessesPaginateTypeDef,
    ListAccessesRequestRequestTypeDef,
    ListedAccessTypeDef,
    ListAgreementsRequestListAgreementsPaginateTypeDef,
    ListAgreementsRequestRequestTypeDef,
    ListedAgreementTypeDef,
    ListCertificatesRequestListCertificatesPaginateTypeDef,
    ListCertificatesRequestRequestTypeDef,
    ListedCertificateTypeDef,
    ListConnectorsRequestListConnectorsPaginateTypeDef,
    ListConnectorsRequestRequestTypeDef,
    ListedConnectorTypeDef,
    ListExecutionsRequestListExecutionsPaginateTypeDef,
    ListExecutionsRequestRequestTypeDef,
    ListHostKeysRequestRequestTypeDef,
    ListedHostKeyTypeDef,
    ListProfilesRequestListProfilesPaginateTypeDef,
    ListProfilesRequestRequestTypeDef,
    ListedProfileTypeDef,
    ListSecurityPoliciesRequestListSecurityPoliciesPaginateTypeDef,
    ListSecurityPoliciesRequestRequestTypeDef,
    ListSecurityPoliciesResponseTypeDef,
    ListServersRequestListServersPaginateTypeDef,
    ListServersRequestRequestTypeDef,
    ListedServerTypeDef,
    ListTagsForResourceRequestListTagsForResourcePaginateTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListUsersRequestListUsersPaginateTypeDef,
    ListUsersRequestRequestTypeDef,
    ListedUserTypeDef,
    ListWorkflowsRequestListWorkflowsPaginateTypeDef,
    ListWorkflowsRequestRequestTypeDef,
    ListedWorkflowTypeDef,
    PaginatorConfigTypeDef,
    ResponseMetadataTypeDef,
    S3TagTypeDef,
    SendWorkflowStepStateRequestRequestTypeDef,
    UserDetailsTypeDef,
    StartFileTransferRequestRequestTypeDef,
    StartFileTransferResponseTypeDef,
    StartServerRequestRequestTypeDef,
    StopServerRequestRequestTypeDef,
    TestIdentityProviderRequestRequestTypeDef,
    TestIdentityProviderResponseTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateAccessResponseTypeDef,
    UpdateAgreementRequestRequestTypeDef,
    UpdateAgreementResponseTypeDef,
    UpdateCertificateRequestRequestTypeDef,
    UpdateCertificateResponseTypeDef,
    UpdateConnectorResponseTypeDef,
    UpdateHostKeyRequestRequestTypeDef,
    UpdateHostKeyResponseTypeDef,
    UpdateProfileRequestRequestTypeDef,
    UpdateProfileResponseTypeDef,
    UpdateServerResponseTypeDef,
    UpdateUserResponseTypeDef,
    WorkflowDetailTypeDef,
    UpdateConnectorRequestRequestTypeDef,
    CreateAccessRequestRequestTypeDef,
    DescribedAccessTypeDef,
    UpdateAccessRequestRequestTypeDef,
    UpdateUserRequestRequestTypeDef,
    CreateAgreementRequestRequestTypeDef,
    CreateConnectorRequestRequestTypeDef,
    CreateProfileRequestRequestTypeDef,
    CreateUserRequestRequestTypeDef,
    DescribedAgreementTypeDef,
    DescribedCertificateTypeDef,
    DescribedConnectorTypeDef,
    DescribedHostKeyTypeDef,
    DescribedProfileTypeDef,
    ImportCertificateRequestRequestTypeDef,
    ImportHostKeyRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    TagResourceRequestRequestTypeDef,
    DescribeSecurityPolicyResponseTypeDef,
    DescribeServerRequestServerOfflineWaitTypeDef,
    DescribeServerRequestServerOnlineWaitTypeDef,
    DescribedUserTypeDef,
    ExecutionStepResultTypeDef,
    FileLocationTypeDef,
    InputFileLocationTypeDef,
    ListAccessesResponseTypeDef,
    ListAgreementsResponseTypeDef,
    ListCertificatesResponseTypeDef,
    ListConnectorsResponseTypeDef,
    ListHostKeysResponseTypeDef,
    ListProfilesResponseTypeDef,
    ListServersResponseTypeDef,
    ListUsersResponseTypeDef,
    ListWorkflowsResponseTypeDef,
    TagStepDetailsTypeDef,
    ServiceMetadataTypeDef,
    WorkflowDetailsTypeDef,
    DescribeAccessResponseTypeDef,
    DescribeAgreementResponseTypeDef,
    DescribeCertificateResponseTypeDef,
    DescribeConnectorResponseTypeDef,
    DescribeHostKeyResponseTypeDef,
    DescribeProfileResponseTypeDef,
    DescribeUserResponseTypeDef,
    ExecutionResultsTypeDef,
    CopyStepDetailsTypeDef,
    DecryptStepDetailsTypeDef,
    ListedExecutionTypeDef,
    CreateServerRequestRequestTypeDef,
    DescribedServerTypeDef,
    UpdateServerRequestRequestTypeDef,
    DescribedExecutionTypeDef,
    WorkflowStepTypeDef,
    ListExecutionsResponseTypeDef,
    DescribeServerResponseTypeDef,
    DescribeExecutionResponseTypeDef,
    CreateWorkflowRequestRequestTypeDef,
    DescribedWorkflowTypeDef,
    DescribeWorkflowResponseTypeDef,
)


def get_structure() -> As2ConnectorConfigTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`types-aiobotocore-transfer` version is the same as related `aiobotocore`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_transfer/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
